/* escr.c: (C) TOYODA Eizi, 1994.10.25
 * ESC R sequences
 */

#include <stdio.h>
#include "neck.h"

#define BUFLEN		256
#define CTRL_A		1

/* ESCR_t():
 * print text to graphics plane.
 */
	static void
ESCR_t()
{
	char	*p, buf[BUFLEN];
	p = buf;
	while ((*p = mygetb(MYFALSE)) != CTRL_A)
		p++;
	*p = NUL;
	(void)label(buf);
}

/* ExecESCR():
 * execute a control sequences.
 */
	static void
ExecESCR(c, cx, param)
	int		c, cx, *param;
{
	if (c=='S') {
		/* remote OS(BASIC) command --- also in hterm */
		rembasic('>');
	} else if (c=='G') {
		(void)openpl();
	} else if (c=='T') {
		(void)closepl();
	} else if (c=='a') {
		if (cx < 5) return;
		(void)arc(param[0], param[1], param[2], param[3], param[4], param[5]);
	} else if (c=='b') {
		if (cx < 3) return;
		(void)rectangle(param[0], param[1], param[2], param[3]);
	} else if (c=='c') {
		if (cx < 2) return;
		(void)circle(param[0], param[1], param[2]);
	} else if (c=='e') {
		(void)erase();
	} else if (c=='f') {
		switch (param[0]) {
		case 1:
			(void)linemod("dotted"); break;
		case 2:
			(void)linemod("longdashed"); break;
		case 3:
			(void)linemod("shortdashed"); break;
		case 4:
			(void)linemod("dotdashed"); break;
		case 0:
		default:
			(void)linemod("solid"); break;
		}
	} else if (c=='l') {
		if (cx < 3) return;
		(void)line(param[0], param[1], param[2], param[3]);
	} else if (c=='m') {
		(void)move(param[0], param[1]);
	} else if (c=='n') {
		(void)cont(param[0], param[1]);
	} else if (c=='p') {
		(void)point(param[0], param[1]);
	} else if (c=='r') {
		if (cx < 3) return;
		(void)fillrectangle(param[0], param[1], param[2], param[3]);
	} else if (c=='t') {
		ESCR_t();
	} else if (c=='s') {
		if (cx < 3) return;
		(void)space(param[0], param[1], param[2], param[3]);
	} else if (c=='x') {
		switch (param[0]) {
		case 0:
			(void)linemod("c.black"); break;
		case 1:
			(void)linemod("c.blue"); break;
		case 2:
			(void)linemod("c.red"); break;
		case 3:
			(void)linemod("c.purple"); break;
		case 4:
			(void)linemod("c.green"); break;
		case 5:
			(void)linemod("c.yellow"); break;
		case 6:
			(void)linemod("c.magenda"); break;
		case 7:
		default:
			(void)linemod("c.white"); break;
		}
	} else {
		/* irresolvable command: display and alart */
		myputc(BEL);
		myputc(c);
	}
}

#define		N_PARAM		(16)

/* esc_r():
 * ESC R entry point.
 */
	void
esc_r()
{
	int		c;		/* command character */
	int		cx;		/* number of parameters */
	int		param[N_PARAM];
	boolean	minus = MYFALSE;
	for (cx=0; cx<N_PARAM; cx++)
		param[cx] = 0;
	cx = 0;
	while ((c = mygetb(MYTRUE)) != EOF) {
		if ('0' <= c && c <= '9') {
			param[cx] *= 10;
			param[cx] += (c - '0');
		} else if (c == '-') {
			minus = MYTRUE;
		} else if (c == ';' || c == ',') {
			if (minus)
				param[cx] = -param[cx];
			if (++cx == N_PARAM)
				break;
		} else if ('@' <= c && c < DEL) {
			ExecESCR(c, cx, param);
			break;
		} else {
			(void)myungetc(c);
			break;
		}
	}
}
