/* neck.h
 * NECK Project common header
 */

#ifndef NECK_H
#define NECK_H 1

/* --- CONFIGURATION --- */

#ifndef SJIS_DEFAULT
#  define SJIS_DEFAULT MYFALSE
#endif

/* --- CONSTANTS --- */

/* characters */
#define NUL		'\000'
#define BEL		'\007'
#define CR		(0x0D)
#define	SUB		'\032'
#define	ESC		'\033'
#define	SPC		' '
#define	BKSL98	(0xFC)
#define DEL		(0x7F)
#define SS2		(0x8E)
#define CSI		(0x9B)
#define	M_SPC	(0xA0)
#define M_DEL	(0xFF)

/* --- TYPE DEFINITION --- */

typedef enum boolean {
	MYFALSE = 0, MYTRUE
} boolean;

/* see MAIN.C for explanation */
typedef struct flag_t {
	boolean		n;
	boolean		sj;
	boolean		c;
	boolean		k;
	boolean		a;
	boolean		ank;
	boolean		ni;
	boolean		v;
	boolean		D;
	boolean		oseven;
} flag_t;

typedef unsigned short wc_t;		/* japanese character */


/* --- FUNCTION PROTOTYPES and EXTERNAL DATA DECLARATION --- */

/* io.c */
extern boolean	myinfile();
extern int		mygetc_s();
extern void		putbyte();
extern void		myputwc();
extern void		myputs();
extern void		nulpadding();
extern void		openl();
extern void		closel();
extern void		initsiso();

/* msb.c */
extern void		msb_on();
extern void		msb_sjis();

/* neck.c */
extern void		rembasic();
extern void		fileloop();

/* ansi.c */
extern void		ansi_csi();
extern void		escswitch();

/* escr.c */
extern void		esc_r();

/* kanzi.c */
extern wc_t		*ksub();

/* nisui.c */
extern wc_t		*nisuient();

/* main.c */
extern void		quit();
extern void		initflag();
extern int		optchar();
extern flag_t	flags;

/* --- MACRO FUNCTIONS --- */

#define mygetc(b)		(mygetc_s((b), MYTRUE))
#define mygetb(b)		(mygetc_s((b), MYTRUE))
#define	myputc(c)		(myputwc(NUL, (c)))
#define	eputs(s)		(void)(fputs((s), stderr))
#define streq(sa,sb)	(strcmp((sa),(sb)) == 0)

#endif /* NECK_H */
/* END OF FILE */
